package de.tudresden.inf.st.eraser;

import de.tudresden.inf.st.eraser.jastadd.model.ColorItem;
import de.tudresden.inf.st.eraser.jastadd.model.Group;
import de.tudresden.inf.st.eraser.jastadd.model.ItemPlaceHolder;
import de.tudresden.inf.st.eraser.jastadd.model.Root;
import org.junit.jupiter.api.Test;

import static org.junit.jupiter.api.Assertions.assertNotNull;

/**
 * Some special corner case with enabled incremental evaluation.
 *
 * @author rschoene - Initial contribution
 */
public class IncrementalTests {

  @Test
  public void unknownGroupPrettyPrint() {
    Root root = Root.createEmptyRoot();
    String output = root.getSmartHomeEntityModel().getUnknownGroup().prettyPrint();
    assertNotNull(output);
  }

  @Test
  public void newGroupPrettyPrint() {
    String output = new Group().setID("group2").setAggregationFunction(null).prettyPrint();
    assertNotNull(output);
  }

  @Test
  public void itemPlaceHolderPrettyPrint() {
    ItemPlaceHolder placeholder = new ItemPlaceHolder().setID("placeholder");
    placeholder.setMetaData(null);
    String output = placeholder.prettyPrint();
    assertNotNull(output);
  }

  @Test
  public void colorItemPrettyPrint() {
    ColorItem item = new ColorItem().setID("colored");
    item.setStateFromString("100,100,100");
    item.setMetaData(null);
    String output = item.prettyPrint();
    assertNotNull(output);
  }
}
